Unit AMY6R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

function AMY6R(var A :Array of Real; N :Integer; I :Integer;
                var J :Integer): Real; 
implementation

function AMY6R(var A :Array of Real; N :Integer; I :Integer;
                var J :Integer): Real;
var
IRO1,IBEG,IEND,K,L :Integer;
T,VMAX :Real;
const
ZERO :Real = 0.0E0;
label
_5,_10,_15;
begin
VMAX := ZERO;
IRO1 := I-1;
IBEG := 1+I*IRO1 div 2;
J := IBEG;
IEND := IBEG+IRO1;
for L:=IBEG to IEND do
 begin
  T := Abs(A[L-1]);
  if ( T <= VMAX ) 
   then goto _5;
  VMAX := T;
  J := L;
_5:
 end;
J := J-IBEG+1;
K := IEND+I;
IEND := N-I;
if ( IEND = 0 ) 
 then goto _15;
for L:=1 to IEND do
 begin
  T := Abs(A[K-1]);
  if ( T <= VMAX ) 
   then goto _10;
  VMAX := T;
  J := I+L;
  K := K+I+L;
_10:
 end;
_15:
Result := VMAX;
end;

end.
